<template>
  <div>
    <div>
      <v-row v-if="hasNotes">
        <v-col class="text-right" xs="6" sm="6" md="6">
          <v-btn outlined>Timeline</v-btn>
        </v-col>
        <v-col xs="6" sm="6" md="6">
          <v-btn outlined>List View</v-btn>
        </v-col>
      </v-row>
      <v-row>
        <v-col>
          <v-timeline dense>
            <v-timeline-item v-for="n in 4" :key="n" large>
              <template v-slot:icon>
                <v-avatar>
                  <img src="http://i.pravatar.cc/64" />
                </v-avatar>
              </template>
              <v-card class="elevation-2">
                <v-card-title class="headline">Lorem ipsum</v-card-title>
                <v-card-text
                  >Lorem ipsum dolor sit amet, no nam oblique veritus. Commune
                  scaevola imperdiet nec ut, sed euismod convenire principes at.
                  Est et nobis iisque percipit, an vim zril disputando
                  voluptatibus, vix an salutandi sententiae.</v-card-text
                >
              </v-card>
            </v-timeline-item>
          </v-timeline>
        </v-col>
      </v-row>
    </div>
    <div v-show="!newNote && !hasNotes">
      You haven't written any notes yet...
      <a @click="newNote = true">Create one now!</a>
    </div>
    <div v-show="newNote">
      <div
        class="text-center display-2 font-weight-thin mb-5 pb-5"
        @click="instantShowSubject = true"
        v-show="!showSubject"
      >
        {{ subject ? subject : "Subject goes here" }}
      </div>
      <v-text-field
        v-show="showSubject"
        ref="subjectField"
        clearable
        autofocus
        v-model="subject"
        @change="instantShowSubject = false"
        @click:clear="instantShowSubject = false"
        @blur="instantShowSubject = false"
      ></v-text-field>
      <!-- Use the component in the right place of the template -->
      <tiptap-vuetify
        :card-props="{ flat: true, outlined: true, color: '#fff' }"
        v-model="content"
        :extensions="extensions"
        placeholder="Start typing here"
      />
      <div class="text-center mt-5 overline">
        <v-icon circle large class="mt-5">mdi-arrow-down</v-icon>
      </div>
      <div class="text-center">
        <v-btn block outlined class="mt-5">Save</v-btn>
        <v-btn text color="red" class="mt-5" @click="newNote = false"
          >Cancel</v-btn
        >
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import {
  TiptapVuetify,
  Heading,
  Bold,
  Italic,
  Strike,
  Underline,
  Code,
  Paragraph,
  BulletList,
  OrderedList,
  ListItem,
  Link,
  Blockquote,
  HardBreak,
  HorizontalRule,
  History
} from "tiptap-vuetify";

export default Vue.extend({
  components: { TiptapVuetify },

  data: () => ({
    extensions: [
      History,
      Blockquote,
      Link,
      Underline,
      Strike,
      Italic,
      ListItem,
      BulletList,
      OrderedList,
      [
        Heading,
        {
          options: {
            levels: [1, 2, 3]
          }
        }
      ],
      Paragraph,
      Bold,
      Code,
      HorizontalRule,
      HardBreak
    ],
    // starting editor's content
    content: "",
    subject: "",
    instantShowSubject: false,
    newNote: false,
    notes: [1, 2, 3]
  }),
  computed: {
    showSubject(): boolean {
      return this.instantShowSubject === true;
    },
    hasNotes(): boolean {
      return this.notes.length > 0;
    }
  }
});
</script>
